// This is a very poor test client for the sequence module

// You are strongly recommended to build your own test client
// note: sequence_print is not tested
//       make sure you do NOT print spaces in your sequence_print
//       for example: [1,3,6] and NOT [1, 3, 6]

#include <assert.h>
#include "sequence.h"

// is_odd(n) determines if n is odd
bool is_odd(int n) {
  return n % 2;
}

// sqr(n) calculates n^2
int sqr(int n) {
  return n * n;
}

int main(void) {
  struct sequence s1 = {0};
  sequence_init(&s1);
  sequence_insert_at(&s1, 0, 1);
  
  struct sequence s2 = {0};
  sequence_init(&s2);
  sequence_insert_at(&s2, 0, 1);
  
  assert(sequence_equiv(&s1, &s2));
  
  assert(sequence_length(&s1) == 1);
  assert(sequence_remove_at(&s1, 0) == 1);
  assert(sequence_length(&s1) == 0);
  sequence_append(&s1, &s2);
  assert(sequence_length(&s1) == 1);
  sequence_append(&s1, &s2);
  assert(sequence_length(&s1) == 2);
  sequence_remove_dups(&s1);
  assert(sequence_length(&s1) == 1);
  sequence_build(&s1, sqr, 2);
  assert(sequence_length(&s1) == 2);
  sequence_filter(&s1, is_odd);
  assert(sequence_length(&s1) == 1);
}
